diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/ap-wifi-mac.cc ns-3.32/src/wifi/model/ap-wifi-mac.cc
--- ns-3.31/src/wifi/model/ap-wifi-mac.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/ap-wifi-mac.cc	2020-10-06 15:35:43.000000000 -0700
@@ -83,11 +83,6 @@
                    BooleanValue (true),
                    MakeBooleanAccessor (&ApWifiMac::m_enableNonErpProtection),
                    MakeBooleanChecker ())
-    .AddAttribute ("RifsMode", "If non-HT STAs are detected, whether to force RIFS to be disabled within the BSS."
-                   "This parameter is only used when HT is supported by the AP.",
-                   BooleanValue (true),
-                   MakeBooleanAccessor (&ApWifiMac::m_disableRifs),
-                   MakeBooleanChecker ())
   ;
   return tid;
 }
@@ -378,7 +373,7 @@
 ApWifiMac::Enqueue (Ptr<Packet> packet, Mac48Address to, Mac48Address from)
 {
   NS_LOG_FUNCTION (this << packet << to << from);
-  if (to.IsBroadcast () || m_stationManager->IsAssociated (to))
+  if (to.IsGroup () || m_stationManager->IsAssociated (to))
     {
       ForwardDown (packet, from, to);
     }
@@ -571,7 +566,7 @@
     {
       operation.SetHtSupported (1);
       operation.SetPrimaryChannel (m_phy->GetChannelNumber ());
-      operation.SetRifsMode (GetRifsMode ());
+      operation.SetRifsMode (false);
       operation.SetNonGfHtStasPresent (IsNonGfHtStasPresent ());
       if (m_phy->GetChannelWidth () > 20)
         {
@@ -927,12 +922,12 @@
       if (GetShortSlotTimeEnabled () == true)
         {
           //Enable short slot time
-          SetSlot (MicroSeconds (9));
+          m_phy->SetSlot (MicroSeconds (9));
         }
       else
         {
           //Disable short slot time
-          SetSlot (MicroSeconds (20));
+          m_phy->SetSlot (MicroSeconds (20));
         }
     }
 }
@@ -1593,28 +1588,6 @@
   return useProtection;
 }
 
-bool
-ApWifiMac::GetRifsMode (void) const
-{
-  bool rifsMode = false;
-  if (GetHtSupported () && !GetVhtSupported ()) //RIFS mode is no longer allowed with 802.11ac or higher
-    {
-      if (m_nonHtStations.empty () || !m_disableRifs)
-        {
-          rifsMode = true;
-        }
-    }
-  if (GetHtSupported () && GetHtConfiguration ()->GetRifsSupported () && rifsMode)
-    {
-      m_stationManager->SetRifsPermitted (true);
-    }
-  else
-    {
-      m_stationManager->SetRifsPermitted (false);
-    }
-  return rifsMode;
-}
-
 uint16_t
 ApWifiMac::GetNextAssociationId (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/ap-wifi-mac.h ns-3.32/src/wifi/model/ap-wifi-mac.h
--- ns-3.31/src/wifi/model/ap-wifi-mac.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/ap-wifi-mac.h	2020-10-06 15:35:43.000000000 -0700
@@ -273,13 +273,6 @@
    */
   bool GetUseNonErpProtection (void) const;
   /**
-   * Return whether RIFS is allowed in the BSS.
-   *
-   * \return true if RIFS is allowed in the BSS,
-   *         false otherwise
-   */
-  bool GetRifsMode (void) const;
-  /**
    * Increment the PCF polling list iterator to indicate
    * that the next polling station can be polled.
    */
@@ -305,7 +298,6 @@
   std::list<Mac48Address> m_cfPollingList;   //!< List of all PCF stations currently associated to the AP
   std::list<Mac48Address>::iterator m_itCfPollingList; //!< Iterator to the list of all PCF stations currently associated to the AP
   bool m_enableNonErpProtection;             //!< Flag whether protection mechanism is used or not when non-ERP STAs are present within the BSS
-  bool m_disableRifs;                        //!< Flag whether to force RIFS to be disabled within the BSS If non-HT STAs are detected
 };
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/channel-access-manager.cc ns-3.32/src/wifi/model/channel-access-manager.cc
--- ns-3.31/src/wifi/model/channel-access-manager.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/channel-access-manager.cc	2020-10-06 15:35:43.000000000 -0700
@@ -114,8 +114,6 @@
     m_lastSwitchingDuration (MicroSeconds (0)),
     m_sleeping (false),
     m_off (false),
-    m_slot (Seconds (0.0)),
-    m_sifs (Seconds (0.0)),
     m_phyListener (0)
 {
   NS_LOG_FUNCTION (this);
@@ -170,32 +168,22 @@
   low->RegisterChannelAccessManager (this);
 }
 
-void
-ChannelAccessManager::SetSlot (Time slotTime)
-{
-  NS_LOG_FUNCTION (this << slotTime);
-  m_slot = slotTime;
-}
-
-void
-ChannelAccessManager::SetSifs (Time sifs)
+Time
+ChannelAccessManager::GetSlot (void) const
 {
-  NS_LOG_FUNCTION (this << sifs);
-  m_sifs = sifs;
+  return m_phy->GetSlot ();
 }
 
-void
-ChannelAccessManager::SetEifsNoDifs (Time eifsNoDifs)
+Time
+ChannelAccessManager::GetSifs (void) const
 {
-  NS_LOG_FUNCTION (this << eifsNoDifs);
-  m_eifsNoDifs = eifsNoDifs;
+  return m_phy->GetSifs ();
 }
 
 Time
 ChannelAccessManager::GetEifsNoDifs () const
 {
-  NS_LOG_FUNCTION (this);
-  return m_eifsNoDifs;
+  return m_phy->GetSifs () + m_phy->GetAckTxTime ();
 }
 
 void
@@ -247,6 +235,12 @@
 {
   NS_LOG_FUNCTION (this << txop);
 
+  // No backoff needed if in sleep mode or off
+  if (m_sleeping || m_off)
+    {
+      return false;
+    }
+
   // the Txop might have a stale value of remaining backoff slots
   UpdateBackoff ();
 
@@ -280,7 +274,7 @@
           // to correctly align the backoff start time at the next slot boundary
           // (performed by the next call to ChannelAccessManager::RequestAccess())
           Time delay = (txop->IsQosTxop () ? Seconds (0)
-                                           : m_sifs + txop->GetAifsn () * m_slot);
+                                           : GetSifs () + txop->GetAifsn () * GetSlot ());
           txop->UpdateBackoffSlotsNow (0, Simulator::Now () + delay);
         }
       else
@@ -315,7 +309,7 @@
   /*
    * EDCAF operations shall be performed at slot boundaries (Sec. 10.22.2.4 of 802.11-2016)
    */
-  Time accessGrantStart = GetAccessGrantStart () + (txop->GetAifsn () * m_slot);
+  Time accessGrantStart = GetAccessGrantStart () + (txop->GetAifsn () * GetSlot ());
 
   if (txop->IsQosTxop () && txop->GetBackoffStart () > accessGrantStart)
     {
@@ -323,8 +317,8 @@
       // time the medium was busy plus an AIFS, hence we need to align it to the
       // next slot boundary.
       Time diff = txop->GetBackoffStart () - accessGrantStart;
-      uint32_t nIntSlots = (diff / m_slot).GetHigh () + 1;
-      txop->UpdateBackoffSlotsNow (0, accessGrantStart + (nIntSlots * m_slot));
+      uint32_t nIntSlots = (diff / GetSlot ()).GetHigh () + 1;
+      txop->UpdateBackoffSlotsNow (0, accessGrantStart + (nIntSlots * GetSlot ()));
     }
 
   UpdateBackoff ();
@@ -408,17 +402,17 @@
 {
   NS_LOG_FUNCTION (this);
   Time lastRxEnd = m_lastRxStart + m_lastRxDuration;
-  Time rxAccessStart = lastRxEnd + m_sifs;
+  Time rxAccessStart = lastRxEnd + GetSifs ();
   if ((lastRxEnd <= Simulator::Now ()) && !m_lastRxReceivedOk)
     {
-      rxAccessStart += m_eifsNoDifs;
+      rxAccessStart += GetEifsNoDifs ();
     }
-  Time busyAccessStart = m_lastBusyStart + m_lastBusyDuration + m_sifs;
-  Time txAccessStart = m_lastTxStart + m_lastTxDuration + m_sifs;
-  Time navAccessStart = m_lastNavStart + m_lastNavDuration + m_sifs;
-  Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + m_sifs;
-  Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + m_sifs;
-  Time switchingAccessStart = m_lastSwitchingStart + m_lastSwitchingDuration + m_sifs;
+  Time busyAccessStart = m_lastBusyStart + m_lastBusyDuration + GetSifs ();
+  Time txAccessStart = m_lastTxStart + m_lastTxDuration + GetSifs ();
+  Time navAccessStart = m_lastNavStart + m_lastNavDuration + GetSifs ();
+  Time ackTimeoutAccessStart = m_lastAckTimeoutEnd + GetSifs ();
+  Time ctsTimeoutAccessStart = m_lastCtsTimeoutEnd + GetSifs ();
+  Time switchingAccessStart = m_lastSwitchingStart + m_lastSwitchingDuration + GetSifs ();
   Time accessGrantedStart;
   if (ignoreNav)
     {
@@ -454,7 +448,7 @@
 {
   NS_LOG_FUNCTION (this << txop);
   Time mostRecentEvent = MostRecent ({txop->GetBackoffStart (),
-                                     GetAccessGrantStart () + (txop->GetAifsn () * m_slot)});
+                                     GetAccessGrantStart () + (txop->GetAifsn () * GetSlot ())});
   NS_LOG_DEBUG ("Backoff start: " << mostRecentEvent.As (Time::US));
 
   return mostRecentEvent;
@@ -464,7 +458,7 @@
 ChannelAccessManager::GetBackoffEndFor (Ptr<Txop> txop)
 {
   NS_LOG_FUNCTION (this << txop);
-  Time backoffEnd = GetBackoffStartFor (txop) + (txop->GetBackoffSlots () * m_slot);
+  Time backoffEnd = GetBackoffStartFor (txop) + (txop->GetBackoffSlots () * GetSlot ());
   NS_LOG_DEBUG ("Backoff end: " << backoffEnd.As (Time::US));
 
   return backoffEnd;
@@ -480,7 +474,7 @@
       Time backoffStart = GetBackoffStartFor (txop);
       if (backoffStart <= Simulator::Now ())
         {
-          uint32_t nIntSlots = ((Simulator::Now () - backoffStart) / m_slot).GetHigh ();
+          uint32_t nIntSlots = ((Simulator::Now () - backoffStart) / GetSlot ()).GetHigh ();
           /*
            * EDCA behaves slightly different to DCA. For EDCA we
            * decrement once at the slot boundary at the end of AIFS as
@@ -498,7 +492,7 @@
             }
           uint32_t n = std::min (nIntSlots, txop->GetBackoffSlots ());
           NS_LOG_DEBUG ("dcf " << k << " dec backoff slots=" << n);
-          Time backoffUpdateBound = backoffStart + (n * m_slot);
+          Time backoffUpdateBound = backoffStart + (n * GetSlot ());
           txop->UpdateBackoffSlotsNow (n, backoffUpdateBound);
         }
       ++k;
@@ -592,7 +586,7 @@
     {
       //this may be caused only if PHY has started to receive a packet
       //inside SIFS, so, we check that lastRxStart was maximum a SIFS ago
-      NS_ASSERT (now - m_lastRxStart <= m_sifs);
+      NS_ASSERT (now - m_lastRxStart <= GetSifs ());
       m_lastRxDuration = now - m_lastRxStart;
     }
   NS_LOG_DEBUG ("tx start for " << duration);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/channel-access-manager.h ns-3.32/src/wifi/model/channel-access-manager.h
--- ns-3.31/src/wifi/model/channel-access-manager.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/channel-access-manager.h	2020-10-06 15:35:43.000000000 -0700
@@ -74,33 +74,6 @@
   void SetupLow (Ptr<MacLow> low);
 
   /**
-   * \param slotTime the duration of a slot.
-   *
-   * It is a bad idea to call this method after RequestAccess or
-   * one of the Notify methods has been invoked.
-   */
-  void SetSlot (Time slotTime);
-  /**
-   * \param sifs the duration of a SIFS.
-   *
-   * It is a bad idea to call this method after RequestAccess or
-   * one of the Notify methods has been invoked.
-   */
-  void SetSifs (Time sifs);
-  /**
-   * \param eifsNoDifs the duration of a EIFS minus the duration of DIFS.
-   *
-   * It is a bad idea to call this method after RequestAccess or
-   * one of the Notify methods has been invoked.
-   */
-  void SetEifsNoDifs (Time eifsNoDifs);
-
-  /**
-   * \return value set previously using SetEifsNoDifs.
-   */
-  Time GetEifsNoDifs (void) const;
-
-  /**
    * \param txop a new Txop.
    *
    * The ChannelAccessManager does not take ownership of this pointer so, the callee
@@ -295,6 +268,25 @@
   void DoGrantPcfAccess (Ptr<Txop> txop);
 
   /**
+   * Return the Short Interframe Space (SIFS) for this PHY.
+   *
+   * \return the SIFS duration
+   */
+  virtual Time GetSifs (void) const;
+  /**
+   * Return the slot duration for this PHY.
+   *
+   * \return the slot duration
+   */
+  virtual Time GetSlot (void) const;
+  /**
+   * Return the EIFS duration minus a DIFS.
+   *
+   * \return the EIFS duration minus a DIFS
+   */
+  virtual Time GetEifsNoDifs (void) const;
+
+  /**
    * typedef for a vector of Txops
    */
   typedef std::vector<Ptr<Txop>> Txops;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/ht-configuration.cc ns-3.32/src/wifi/model/ht-configuration.cc
--- ns-3.31/src/wifi/model/ht-configuration.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/ht-configuration.cc	2020-10-06 15:35:43.000000000 -0700
@@ -58,12 +58,6 @@
                    MakeBooleanAccessor (&HtConfiguration::GetGreenfieldSupported,
                                         &HtConfiguration::SetGreenfieldSupported),
                    MakeBooleanChecker ())
-    .AddAttribute ("RifsSupported",
-                   "Whether or not RIFS is supported.",
-                   BooleanValue (false),
-                   MakeBooleanAccessor (&HtConfiguration::SetRifsSupported,
-                                        &HtConfiguration::GetRifsSupported),
-                   MakeBooleanChecker ())
     ;
     return tid;
 }
@@ -94,17 +88,4 @@
   return m_greenfieldSupported;
 }
 
-void
-HtConfiguration::SetRifsSupported (bool enable)
-{
-  NS_LOG_FUNCTION (this << enable);
-  m_rifsSupported = enable;
-}
-
-bool
-HtConfiguration::GetRifsSupported (void) const
-{
-  return m_rifsSupported;
-}
-
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/ht-configuration.h ns-3.32/src/wifi/model/ht-configuration.h
--- ns-3.31/src/wifi/model/ht-configuration.h	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/ht-configuration.h	2020-10-06 15:35:43.000000000 -0700
@@ -73,25 +73,10 @@
    *         false otherwise.
    */
   bool GetGreenfieldSupported (void) const;
-  /**
-   * Enable or disable RIFS support.
-   *
-   * \param enable true if RIFS is to be supported,
-   *               false otherwise
-   */
-  void SetRifsSupported (bool enable);
-  /**
-   * \return whether the device supports RIFS capability.
-   *
-   * \return true if short RIFS is supported,
-   *         false otherwise.
-   */
-  bool GetRifsSupported (void) const;
 
 
 private:
   bool m_sgiSupported;        ///< flag whether short guard interval is supported
-  bool m_rifsSupported;       ///< flag whether RIFS is supported
   bool m_greenfieldSupported; ///< flag whether Greenfield is supported
 };
 
diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/wifi/model/interference-helper.cc ns-3.32/src/wifi/model/interference-helper.cc
--- ns-3.31/src/wifi/model/interference-helper.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/wifi/model/interference-helper.cc	2020-10-06 15:35:43.000000000 -0700
@@ -167,7 +167,7 @@
   WifiMacHeader hdr;
   hdr.SetType (WIFI_MAC_QOSDATA);
   Ptr<WifiPpdu> fakePpdu = Create<WifiPpdu> (Create<WifiPsdu> (Create<Packet> (0), hdr),
-                                             WifiTxVector (), duration, 0);
+                                             WifiTxVector (), duration, WIFI_PHY_BAND_UNSPECIFIED);
   Add (fakePpdu, WifiTxVector (), duration, rxPowerW);
 }
 
